Index: cpp/frams/genetics/f9/f9_conv.cpp
===================================================================
--- cpp/frams/genetics/f9/f9_conv.cpp	(revision 1279)
+++ cpp/frams/genetics/f9/f9_conv.cpp	(revision 1280)
@@ -92,5 +92,5 @@
 int GenoConv_f90::findVertexAt(vector<XYZ_LOC> &vertices, const XYZ_LOC &vertex)
 {
-	for (size_t i = 0; i < vertices.size(); i++)
+	for (int i = 0; i < vertices.size(); i++)
 		if (vertices[i].same_coordinates(vertex)) return i;
 	return -1;
Index: cpp/frams/genetics/fF/fF_oper.cpp
===================================================================
--- cpp/frams/genetics/fF/fF_oper.cpp	(revision 1279)
+++ cpp/frams/genetics/fF/fF_oper.cpp	(revision 1280)
@@ -49,5 +49,5 @@
 	par.load(gene);
 	static const int propsToMutate[] = fF_PROPS_TO_MUTATE;
-	int which = rndUint(std::size(propsToMutate));
+	int which = rndUint((unsigned int)std::size(propsToMutate));
 	bool mutated_ok = GenoOperators::mutatePropertyNaive(par.param, propsToMutate[which]);
 	if (mutated_ok)
Index: cpp/frams/genetics/fL/fL_general.cpp
===================================================================
--- cpp/frams/genetics/fL/fL_general.cpp	(revision 1279)
+++ cpp/frams/genetics/fL/fL_general.cpp	(revision 1280)
@@ -555,5 +555,5 @@
 	//branch->processDefinition(this);
 
-	builtincount = words.size();
+	builtincount = (int)words.size();
 }
 
@@ -1383,10 +1383,10 @@
 int fL_Builder::countDefinedWords()
 {
-	return words.size() - builtincount;
+	return (int)words.size() - builtincount;
 }
 
 int fL_Builder::countWordsInLSystem()
 {
-	int count = genotype.size();
+	size_t count = genotype.size();
 	for (fL_Rule *rul : rules)
 	{
@@ -1394,5 +1394,5 @@
 	}
 	count += words.size();
-	return count;
+	return int(count);
 }
 
Index: cpp/frams/model/autoname.cpp
===================================================================
--- cpp/frams/model/autoname.cpp	(revision 1279)
+++ cpp/frams/model/autoname.cpp	(revision 1280)
@@ -59,5 +59,5 @@
 static void przeplatanka(char *out, char *in1, char *in2)
 {
-	int d1 = strlen(in1), d2 = strlen(in2);
+	int d1 = (int)strlen(in1), d2 = (int)strlen(in2);
 	int p1 = 0, p2 = 0;
 	int pp = d1 + d2;
Index: cpp/frams/model/model.cpp
===================================================================
--- cpp/frams/model/model.cpp	(revision 1279)
+++ cpp/frams/model/model.cpp	(revision 1280)
@@ -610,5 +610,5 @@
 int Model::getCheckpointCount()
 {
-	return checkpoints.size();
+	return (int)checkpoints.size();
 }
 
Index: cpp/frams/model/modelparts.h
===================================================================
--- cpp/frams/model/modelparts.h	(revision 1279)
+++ cpp/frams/model/modelparts.h	(revision 1280)
@@ -229,5 +229,5 @@
 	SString name, longname, description;
 	ParamEntry *props;
-	bool ownedprops;//< destructor will free props using ParamObject::freeParamTab
+	bool ownedprops; //< destructor will free props using ParamObject::freeParamTab
 	paInt prefinputs, prefoutput;
 	paInt preflocation;
@@ -304,8 +304,9 @@
 		return vectordata;
 	}
-	void setSymbolGlyph(int *data, bool owned = 1)
+	void setSymbolGlyph(int *data, bool owned = true)
 	{
 		if (vectordata && ownedvectordata) delete[]vectordata;
-		vectordata = data; ownedvectordata = owned;
+		vectordata = data;
+		ownedvectordata = owned;
 	}
 	/** additional information about how the neuron should be drawn
Index: cpp/frams/model/similarity/simil-match.cpp
===================================================================
--- cpp/frams/model/similarity/simil-match.cpp	(revision 1279)
+++ cpp/frams/model/similarity/simil-match.cpp	(revision 1280)
@@ -69,5 +69,5 @@
 
 	// return the result
-	return m_apvMatched[Obj]->size();
+	return (int)m_apvMatched[Obj]->size();
 }
 
Index: cpp/frams/util/sstring-simple.cpp
===================================================================
--- cpp/frams/util/sstring-simple.cpp	(revision 1279)
+++ cpp/frams/util/sstring-simple.cpp	(revision 1280)
@@ -78,5 +78,5 @@
 void SString::endWrite(int newlength)
 {
-	if (newlength < 0) newlength = strlen(txt);
+	if (newlength < 0) newlength = (int)strlen(txt);
 	else
 	{
@@ -95,5 +95,5 @@
 void SString::endAppend(int newappend)
 {
-	if (newappend < 0) endWrite(appending + strlen(txt + appending));
+	if (newappend < 0) endWrite(appending + (int)strlen(txt + appending));
 	else endWrite(newappend + appending);
 }
@@ -104,5 +104,5 @@
 {
 	if (!s) return;
-	int x = strlen(s);
+	int x = (int)strlen(s);
 	if (!x) return;
 	append(s, x);
@@ -137,5 +137,5 @@
 {
 	if (!ch) chlen = 0;
-	else if (chlen < 0) chlen = strlen(ch);
+	else if (chlen < 0) chlen = (int)strlen(ch);
 	if (chlen)
 	{