Index: cpp/tests/evol_test-fL.goal
===================================================================
--- cpp/tests/evol_test-fL.goal	(revision 1143)
+++ cpp/tests/evol_test-fL.goal	(revision 1301)
@@ -1,47 +1,61 @@
 Evaluation 0	34,37.6,38	2,2,2	1,1,1	0,0,0	0,0,0	31,34.6,35
-Evaluation 10	29,40.4,56	2,2,2	1,1,1	0,0,0	0,0,0	26,37.4,53
-Evaluation 20	29,53,98	2,2.2,3	1,1.2,2	0,0.5,2	0,0.2,1	26,48.9,90
-Evaluation 30	29,80,119	2,2.3,3	1,1.3,2	0,1.2,2	0,0.6,1	26,74.6,111
-Evaluation 40	29,84.7,147	2,2.4,4	1,1.4,3	0,1.2,2	0,0.6,1	26,79.1,137
-Evaluation 50	34,126.8,162	2,3.5,4	1,2.5,3	0,2,3	0,0.5,1	31,118.3,151
-Evaluation 60	124,148.5,162	4,4,4	3,3,3	2,2.6,3	0,0.6,1	115,138.3,151
-Evaluation 70	133,158,178	4,4.2,5	3,3.2,4	2,2.9,4	0,0.8,1	124,146.9,167
-Evaluation 80	136,159.7,173	4,4.4,5	3,3.4,4	2,2.8,3	1,1,1	126,148.1,162
-Evaluation 90	136,163,189	4,4.6,5	3,3.6,4	2,2.8,3	1,1,1	126,151,178
-Evaluation 99	136,168.2,189	4,4.8,5	3,3.8,4	2,2.9,3	1,1,1	126,155.7,178
-167.0	//L
-w:w0
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.993)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), maxwords=300
+Evaluation 10	34,47.7,77	2,2,2	1,1,1	0,0.2,1	0,0,0	31,44.5,74
+Evaluation 20	34,44.8,55	2,2,2	1,1,1	0,0,0	0,0,0	31,41.8,52
+Evaluation 30	34,46.4,55	2,2,2	1,1,1	0,0.1,1	0,0,0	31,43.3,52
+Evaluation 40	34,51.6,79	2,2,2	1,1,1	0,0.1,1	0,0,0	31,48.5,76
+Evaluation 50	36,52.8,62	2,2,2	1,1,1	0,0.3,1	0,0,0	32,49.5,58
+Evaluation 60	36,65.2,88	2,2.1,3	1,1.1,2	0,0.8,1	0,0,0	32,61.2,82
+Evaluation 70	36,70.5,96	2,2.2,3	1,1.2,2	0,1,2	0,0,0	32,66.1,90
+Evaluation 80	69,85.3,123	2,2,2	1,1,1	1,1.1,2	0,0,0	64,81.2,119
+Evaluation 90	70,98.3,127	2,2,2	1,1,1	1,1.1,2	0,0,0	66,94.2,123
+Evaluation 99	93,117.9,143	2,2,2	1,1,1	1,1.4,2	0,0.2,1	89,113.3,137
+143.0	//L
+w:w0, 2
+w:w1, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)w0()N(d=@:p=0.925)C(-0.6802658420056105)N(d=G)S(), 0.0, maxwords=300
 
-162.0	//L
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.947)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), maxwords=300
+127.0	//L
+w:w1, 2
+w:w0, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)w0()C(-0.6802658420056105)N(d=G)S(), 0.0, maxwords=300
 
-167.0	//L
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.947)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), 0.0, maxwords=300
+123.0	//L
+w:w0, 2
+w:w1, 2
+i:axiom=N(d=Gpart:ry=-0.962)rotY(1.9037489495240152)C(0.7401745021343231)N(d=G)S(), 0.0, maxwords=300
 
-136.0	//L
-i:axiom=N(d=@:p=0.993)N(d=@:p=0.975)S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), maxwords=300
+143.0	//L
+w:w0, 2
+w:w1, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)w0()N(d=@:p=0.925)C(-0.6802658420056105)N(d=G)S(), 0.0, maxwords=300
 
-189.0	//L
-i:axiom="N(d=Gpart:rz=-0.665)N(d=@:p=0.947)N(d=@:p=0.975)S()S(fr=0.8289400283247232, stam=0.4012594970408827)S()C(-0.7881847871467471)S(stam=0.5370225172955543)", maxwords=300
+102.0	//L
+w:w1, 2
+w:w0, 2
+i:axiom=rotY(1.9037489495240152)C(0.7401745021343231)N(d=G)S(), 0.0, maxwords=300
 
-167.0	//L
-w:w0
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.993)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), maxwords=300
+96.0	//L
+w:w1, 2
+w:w0, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)N(d=G)S(), maxwords=300
 
-172.0	//L
-w:w0
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.993)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), 0.0, maxwords=300
+123.0	//L
+w:w1, 2
+w:w0, 2
+i:axiom=N(d=Gpart:ry=-0.962)rotY(1.9037489495240152)C(0.7401745021343231)N(d=G)S(), 0.0, maxwords=300
 
-166.0	//L
-w:w0
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.99)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), maxwords=300
+93.0	//L
+w:w0, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)N(d=G)S(), 0.0, maxwords=300
 
-189.0	//L
-w:w0
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.993)N(d=@:p=0.975)S()S(fr=0.8289400283247232)C(-0.8130810903385282)C(-0.7881847871467471)S(stam=0.5370225172955543), 0.0, maxwords=300
+127.0	//L
+w:w0, 2
+w:w1, 2
+i:axiom=rotX(1.354823648929596)C(0.7401745021343231)w0()C(-0.6802658420056105)N(d=G)S(), 0.0, maxwords=300
 
-167.0	//L
-i:axiom=N(d=Gpart:rz=-0.665)N(d=@:p=0.947)N(d=@:p=0.975)S()S(fr=0.8289400283247232)S()C(-0.7881847871467471)S(stam=0.5370225172955543), 0.0, maxwords=300
+102.0	//L
+w:w0, 2
+w:w1, 2
+i:axiom=rotY(1.9037489495240152)C(0.7401745021343231)N(d=G)S(), 0.0, maxwords=300
 
 