Index: cpp/tests/evol_test-fH.goal
===================================================================
--- cpp/tests/evol_test-fH.goal	(revision 1301)
+++ cpp/tests/evol_test-fH.goal	(revision 1320)
@@ -1,148 +1,79 @@
-Evaluation 0	7,7.6,13	2,2.1,3	1,1.1,2	0,0,0	0,0,0	4,4.4,8
-Evaluation 10	7,95.7,300	2,2.6,4	1,1.6,3	0,0.3,1	0,0,0	4,91.2,292
-Evaluation 20	7,213.5,441	2,3.2,4	1,2.2,3	0,0.5,1	0,0,0	4,207.6,433
-Evaluation 30	154,500.3,868	3,4.5,5	2,3.5,4	0,1.1,2	0,0,0	147,491.2,857
-Evaluation 40	421,597.5,868	4,4.8,6	3,3.8,5	0,1.2,2	0,0,0	412,587.7,857
-Evaluation 50	421,768.7,1432	4,5.6,9	3,4.6,8	0,1.5,3	0,0,0	412,757,1413
-Evaluation 60	453,958.1,1444	3,6.7,10	2,5.7,9	1,1.8,3	0,0,0	445,943.9,1424
-Evaluation 70	453,1125.2,1582	4,7.6,9	3,6.6,8	1,2,3	0,0,0	445,1109,1562
-Evaluation 80	878,1350,1590	7,8.2,10	6,7.2,9	2,2.6,3	0,0,0	863,1332,1570
-Evaluation 90	595,1179.2,1736	6,7.7,10	5,6.7,9	1,2.3,4	0,0,0	583,1162.5,1713
-Evaluation 99	1015,1336.6,1736	7,8.4,10	6,7.4,9	2,2.9,4	0,0,0	998,1317.9,1713
-1735.0	//H
+Evaluation 0	7,7.1,8	2,2,2	1,1,1	0,0,0	0,0,0	4,4.1,5
+Evaluation 10	7,88.1,195	2,2.2,3	1,1.2,2	0,0.3,1	0,0,0	4,84.4,189
+Evaluation 20	16,165.5,336	2,2.8,4	1,1.8,3	0,0.2,1	0,0,0	13,160.7,328
+Evaluation 30	35,198.1,467	2,2.7,4	1,1.7,3	0,0.2,1	0,0,0	32,193.5,459
+Evaluation 40	35,180.4,293	2,2.6,4	1,1.6,3	0,0.1,1	0,0,0	32,176.1,289
+Evaluation 50	153,344.4,722	2,3.1,4	1,2.1,3	0,0.5,2	0,0,0	150,338.7,713
+Evaluation 60	152,492.2,1713	2,3.2,7	1,2.2,6	0,1,4	0,0.2,2	149,485.6,1694
+Evaluation 70	153,358,722	2,2.7,4	1,1.7,3	0,0.8,2	0,0,0	150,352.8,713
+Evaluation 80	278,506.4,1397	2,2.9,5	1,1.9,4	0,1.7,6	0,0,0	273,499.9,1382
+Evaluation 90	276,435.3,568	2,2.7,3	1,1.7,2	0,1.4,2	0,0,0	272,429.5,561
+Evaluation 99	278,526.3,998	3,3.5,6	2,2.5,5	0,1.2,2	0,0,0	273,519.1,985
+425.0	//H
 3
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.363
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.51
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
 
-1278.0	//H
+563.0	//H
 3
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.364
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:
-j:0.2289294134825468, -0.9338508220389485, -0.9687878657132387, 0.6790259419940412, 0.04474106524139643, 0.026149732992053032, rotstif=0.98
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-c:0.23696052748709917, 0.948512434028089, 0.9806900122202933, -0.5106971822679043, -0.25135360984131694, -0.9086807160638273, 0.005
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.216
+j:0.7719245310872793, -0.29625887237489223, 0.4767806753516197, 0.6783782416023314, -0.524516352917999, 0.004778912756592035, rotstif=0.889
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.30929664289578795, 0.8561625853180885, 0.4088287986814976, 0.8882395019754767, 0.21650573518127203, 0.19331082561984658, d=N:s=-0.105
 
-1146.0	//H
+582.0	//H
 3
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:
-j:0.2289294134825468, -0.9338508220389485, -0.9687878657132387, 0.6790259419940412, 0.04474106524139643, 0.026149732992053032, rotstif=0.98
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:0.2685481063090265, 0.9178985385224223, 0.30558063788339496, 0.9767476636916399, -0.7959103863686323, -0.5822464828379452, rotstif=0.793, l=1.03
+j:0.7719245310872793, -0.29625887237489223, 0.4767806753516197, 0.6783782416023314, -0.524516352917999, 0.004778912756592035, rotstif=0.889
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
 
-1448.0	//H
+425.0	//H
 3
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.3556330786086619, -0.459984062705189, 0.47038804087787867, 0.13923680875450373, 0.40747456159442663, -0.4230471351183951, l=0.966
-j:-0.7859917231835425, 0.17938943253830075, 0.49079614458605647, 0.16680837189778686, 0.8729361924342811, 0.8815633179619908, fr=0.267, l=1.217
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.363
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.311
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
 
-1278.0	//H
+278.0	//H
 3
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:
-j:0.2289294134825468, -0.9338508220389485, -0.9687878657132387, 0.6790259419940412, 0.04474106524139643, 0.026149732992053032, rotstif=0.98
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-c:0.23696052748709917, 0.948512434028089, 0.9806900122202933, -0.5106971822679043, -0.25135360984131694, -0.9086807160638273, 0.005
+j:0.2685481063090265, 0.9178985385224223, 0.30558063788339496, 0.9767476636916399, -0.7959103863686323, -0.5822464828379452, rotstif=0.793, l=1.03
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.405, -0.1714740232564509, l=1.359
 
-1438.0	//H
+563.0	//H
 3
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.3556330786086619, -0.459984062705189, 0.47038804087787867, 0.13923680875450373, 0.40747456159442663, -0.4230471351183951, l=0.966
-j:-0.7859917231835425, 0.17938943253830075, 0.49079614458605647, 0.16680837189778686, 0.8729361924342811, 0.8815633179619908, l=1.217
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.363
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+j:0.7719245310872793, -0.29625887237489223, 0.4767806753516197, 0.6783782416023314, -0.524516352917999, 0.004778912756592035, rotstif=0.889
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.30929664289578795, 0.8561625853180885, 0.4088287986814976, 0.8882395019754767, 0.21650573518127203, 0.19331082561984658, d=N:s=-0.105
 
-1015.0	//H
+998.0	//H
 3
-j:
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:0.2685481063090265, 0.9178985385224223, 0.30558063788339496, 0.9767476636916399, -0.7959103863686323, -0.5822464828379452, rotstif=0.793, l=1.03
+j:0.7719245310872793, -0.29625887237489223, 0.4767806753516197, 0.6783782416023314, -0.524516352917999, 0.004778912756592035, rotstif=0.889
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+j:0.7719245310872793, -0.29625887237489223, 0.4767806753516197, 0.6783782416023314, -0.524516352917999, 0.004778912756592035, rotstif=0.889
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
+n:-0.30929664289578795, 0.8561625853180885, 0.4088287986814976, 0.8882395019754767, 0.21650573518127203, 0.19331082561984658, d=N:s=-0.105
 
-1023.0	//H
+435.0	//H
 3
-j:fr=0.866
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:0.2685481063090265, 0.9178985385224223, 0.30558063788339496, 0.9767476636916399, -0.7959103863686323, -0.5822464828379452, rotstif=0.793, l=1.03
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
 
-1736.0	//H
+435.0	//H
 3
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.363
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, fr=0.129, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
 
-1269.0	//H
+559.0	//H
 3
-j:-0.06737845437601209, -0.511148823890835, -0.6820608270354569, -0.050604989752173424, 0.24702021200209856, -0.3239847649820149, fr=0.919, l=1.232
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:
-j:0.3556330786086619, -0.459984062705189, 0.47038804087787867, 0.13923680875450373, 0.40747456159442663, -0.4230471351183951, l=0.966
-j:0.7835460035130382, 0.9273255281150341, -0.23311695735901594, -0.8865740485489368, -0.45468741096556187, -0.0446697766892612, l=1.272
-j:-0.7859917231835425, 0.17938943253830075, 0.49079614458605647, 0.16680837189778686, 0.8729361924342811, 0.8815633179619908, l=1.217
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-n:0.1043849429115653, 0.16895214468240738, 0.9238727670162916, 0.4633875167928636, -0.9087707279250026, -0.5816859439946711, d=Gpart:ry=-1.415
-c:0.23696052748709917, 0.948512434028089, 0.9806900122202933, -0.5106971822679043, -0.25135360984131694, -0.9086807160638273, 0.005
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+j:-0.038212927524000406, 0.37732237251475453, 0.7609517863020301, -0.7625445714220405, -0.3640336534008384, -0.1714740232564509, l=1.359
+n:-0.4936176179908216, -0.7378895306028426, -0.9759275536052883, 0.5421781041659415, -0.24754683719947934, -0.017950518522411585, d=N:s=-0.244
+n:0.6790259419940412, 0.04474106524139643, 0.026149732992053032, -0.9338508220389485, -0.9687878657132387, -0.14240856189280748, d=*
 
 